!!! [2D flat reflector]cos correction for kz after migration -- Yi Shen, Apr 8, 2012
!!! The data should be[1D]: offset/angle (kz is the amplitude) or [2D] in the following order: kz, offset/angle...
!!! cos_stretch.x < spectra.H  z=[1500 ] ang=[n]> output.H
!!! z=[]: the depth of the reflector
!!! ang=[n]: offset or angle for the input
!!! dimen=[2]: 1D or 2D for the input
program cos_stretch
  use sep
  use util_axisIO

  implicit none

 
  integer 			:: n1, n2
  integer			:: i1, i2
  real				:: d1,o1, d2, o2, ok, dk
  logical			:: ang
  real				:: z
  real,  allocatable 		:: input(:,:), output(:,:)
  real				:: offset, angle, corr
  real				:: loc
  real    			:: ll, wt
  integer 			:: ill,il

  call sep_init()


  call from_param('ang',ang,.false.)
  call from_param('z',z, 1500.)


  

  call from_history ('n1', n1)
  call from_history ("d1", d1)
  call from_history ("o1", o1)


  call from_history ('n2', n2)
  call from_history ("d2", d2)
  call from_history ("o2", o2) 


  allocate(input(n1, n2))
  call sep_read(input)
  
!   if (ang) then
! 	ncorr=n1/cos(d2*(n2-1)+o2)+1.5
!   else
!  	 ncorr=n1/cos(atan(abs(d2*(n2-1)+o2)/z))
!   end if
  if (ang) then
	dk=d1/cos(d2*(n2-1)+o2)
	ok=o1/cos(d2*(n2-1)+o2)
  else
 	 dk=d1/cos(atan(abs(d2*(n2-1)+o2)/z))
 	 ok=o1/cos(atan(abs(d2*(n2-1)+o2)/z))
  end if

  allocate(output(n1, n2))

  output=0.
  do i2=1, n2   !!! loop over offset/angle

  	if (ang) then
		angle=d2*(i2-1)+o2
	else
		offset=d2*(i2-1)+o2
		angle=atan(abs(offset)/z)
	end if
	corr=cos(angle)

	do i1=1, n1-1
! 		loc=(o1+(i1-1)*d1)/corr
! 		ll = (loc-o1)/d1
!         	ill=ll
!        		il=1+ill  
!        		wt = ll-ill	!!!linear intepolation	
			
! 		output(il,i2)=input(i1,i2)*(1.-wt)
! 		output(il+1,i2)=input(i1,i2)*wt
!		loc=(ok+(i1-1)*dk)*corr
		loc=(o1+(i1-1)*d1)*corr
		ll = (loc-o1)/d1
        	ill=ll
       		il=1+ill  
       		wt = ll-ill

		output(i1,i2)=input(il,i2)*(1.-wt)+input(il+1,i2)*wt
	end do
  end do

  


  call to_history ('n1', n1)
  call to_history ("d1", d1)
  call to_history ("o1", o1)

  call to_history ('n2', n2)
  call to_history ('d2', d2)
  call to_history ('o2', o2)

  call sep_write(output)
  deallocate(input, output)

  
	
  call sep_close()
end program

